package checkAlign;

import java.io.*;
import java.util.*;

public class SearchTable {
	public SearchTable(){
				
	}
	public String getLine(int numSeq, int numLetters, boolean includeGaps){
		String input = "";
		BufferedReader br;
		String line = "";
		int counter = 0;
		ResourceBundle resources = null;
		
		try {
            resources = ResourceBundle.getBundle("resources.config", Locale.getDefault());
		}catch(MissingResourceException mre){
			System.out.println("Un fallo de recursos");
		}
		
		// select a table
		if (numLetters == 5 && !includeGaps) numLetters = 4;
		if (numLetters == 21 && !includeGaps) numLetters = 20;
		
		if (numLetters == 4){
			input = resources.getString("calhnb4");
		}else if (numLetters == 5){
			input = resources.getString("calhnb5");
		}else if (numLetters == 20){
			input = resources.getString("calhna4");
		}else if (numLetters == 21){
			input = resources.getString("calhna5");
		}else{
			System.out.println("Table not valid");
			System.exit(0);
		}
		
		InputStream is = getClass().getResourceAsStream(input);
		
		if (numSeq > 200) numSeq = 200;
		//skip comments, lines starting with #
		int lineStart = -1;
		boolean startRead = false;
		
		try{
			br = new BufferedReader(new InputStreamReader(is));
			while ((line = br.readLine()) != null){				
				if (startRead && counter == numSeq + lineStart){
					break;
				}
				counter ++;
				if (line.charAt(0) == '#') lineStart++;
				else startRead = true;
			}
			br.close();
			
		}catch(Exception ex){
			ex.printStackTrace();
		}
		
		return line;
	}
	double getE(String line){
		int counter = 0;
		StringTokenizer st = new StringTokenizer(line);
		String value = "";
		
		while (st.hasMoreTokens()){
			value = st.nextToken();
			if (counter == 7){
				break;
			}	
			counter ++;
		}
		return Double.parseDouble(value);
	}
	double getSd(String line){
		int counter = 0;
		StringTokenizer st = new StringTokenizer(line);
		String value = "";
		
		while (st.hasMoreTokens()){
			value = st.nextToken();
			if (counter == 8){
				break;
			}	
			counter ++;
		}
		return Double.parseDouble(value);
	}
}
